// Member initialization list
/*  Constructorii 
 * 	- functii membre speciale
 *  - au numele clasei
 *  - nu returneaza nimic, nici macar void
 *  - se apeleaza implicit sau explicit la construirea oricarui obiect
 *  - servesc la initializarea membrilor clasei
 */  

#include <iostream>
#include <fstream>
using namespace std;

class A {
	int x;
	char ch;
public:
	A();
	A(int i, char c);      
   ~A();
	int GetX() const;
	char GetC() const;
};


A::A() : x(0), ch('\0')
{ 
}
	
A::A(int i, char c) : x(i), ch(c)      
{
}

A::~A()
{
	cout << "Destructor\n";
} 
	
int A::GetX() const
{
	return x;
}

char A::GetC() const
{
	return ch;
}
	
int main()
{

	A ob1;          // Apel IMPLICIT al constructorului A()
	A ob2 = A();    // Apel EXPLICIT al constructorului A()
	
	A ob3(100, 'Y');      // Apel IMPLICIT al constructorului A(int. char)
	A ob4 = A(290, 'H');  // Apel EXPLICIT al constructorului A(int, char)	
	
//	cout << ob4.GetX() << ' ' << ob4.GetC();
	
	return 0;
}


