// Member initialization list
/*  Constructorii 
 * 	- functii membre speciale
 *  - au numele clasei
 *  - nu returneaza nimic, nici macar void
 *  - se apeleaza implicit sau explicit la construirea oricarui obiect
 *  - servesc la initializarea membrilor clasei
 */  

#include <iostream>
#include <fstream>
using namespace std;

class Elev {
	string nume;
	int varsta;
	char sex;
public:
	Elev();
	Elev(string, int, char);      
	string GetNume() const;
	int GetVarsta() const;
	char GetSex() const;
};

Elev::Elev() : nume("Nelutu"), varsta(18), sex('M')
{ 
}
	
Elev::Elev(string num, int v, char s) : nume(num), varsta(v), sex(s)
{
}

string Elev::GetNume() const
{
	return nume;
}

char Elev::GetSex() const
{
	return sex;
}

int Elev::GetVarsta() const
{
	return varsta;
}

	
int main()
{
	Elev ob1;          // Apel IMPLICIT al constructorului Elev()
	Elev ob2 = Elev();    // Apel EXPLICIT al constructorului Elev()
	
	Elev ob3("Georgica", 17, 'M');      // Apel IMPLICIT al constructorului Elev(string, int, char)
	Elev ob4 = Elev("Alina", 18, 'F');  // Apel EXPLICIT al constructorului Elev(string, int, char)
	
	cout << ob4.GetNume() << ' ' << ob4.GetVarsta() << ' ' << ob4.GetSex();
	
	return 0;
}


